/* File da includere --- INIZIO */
!include "StrFunc.nsh"
${StrCase}
!include "MUI.nsh"
/* File da includere --- FINE */

/* MUI Settings --- INIZIO */
!define MUI_ABORTWARNING
!define MUI_ICON "${NSISDIR}\Contrib\Graphics\Icons\modern-install.ico"
!define MUI_UNICON "${NSISDIR}\Contrib\Graphics\Icons\modern-uninstall.ico"
!define MUI_COMPONENTSPAGE_SMALLDESC
!define MUI_FINISHPAGE_NOAUTOCLOSE
!define MUI_UNFINISHPAGE_NOAUTOCLOSE
!define MUI_HEADERIMAGE_BITMAP "${NSISDIR}\Contrib\Graphics\Header\orange.bmp"
!define MUI_HEADERIMAGE_UNBITMAP "${NSISDIR}\Contrib\Graphics\Header\orange-uninstall.bmp"
!define MUI_WELCOMEFINISHPAGE_BITMAP "${NSISDIR}\Contrib\Graphics\Wizard\orange.bmp"
!define MUI_UNWELCOMEFINISHPAGE_BITMAP "${NSISDIR}\Contrib\Graphics\Wizard\orange-uninstall.bmp"
/* MUI Settings --- FINE */

/* Impostazioni generali --- INIZIO */
!define PRODUCT_NAME "My Application"
!define PRODUCT_VERSION "1.0"
!define PRODUCT_PUBLISHER "Il nome della mia ditta s.r.l."
!define PRODUCT_WEB_SITE "http://www.ilsitodellamiaditta.it/"
!define PRODUCT_UNINST_KEY "Software\Microsoft\Windows\CurrentVersion\Uninstall\${PRODUCT_NAME}"
!define PRODUCT_UNINST_ROOT_KEY "HKLM"
/* Impostazioni generali --- FINE */

/* --- Installer pages --- INIZIO */
; Welcome page
!insertmacro MUI_PAGE_WELCOME
; Pagina con la lista dei componenti da installare
!insertmacro MUI_PAGE_COMPONENTS
; Instfiles page
!insertmacro MUI_PAGE_INSTFILES
; Finish page
!insertmacro MUI_PAGE_FINISH
/* --- Installer pages --- FINE */

/* --- Uninstaller pages --- INIZIO */
; Welcome page
!insertmacro MUI_UNPAGE_WELCOME
; Pagina con la lista dei componenti da rimuovere
!insertmacro MUI_UNPAGE_COMPONENTS
; Instfiles page
!insertmacro MUI_UNPAGE_INSTFILES
; Finish page
!insertmacro MUI_UNPAGE_FINISH
/*  --- Uninstaller pages --- FINE */

; Language files
!insertmacro MUI_LANGUAGE "Italian"

/* --- Installer Attributes --- INIZIO */
BrandingText "L'installer della mia ditta"

Name "${PRODUCT_NAME} ${PRODUCT_VERSION}"
OutFile "${PRODUCT_NAME}Setup.exe"
InstallDir "$PROGRAMFILES\${PRODUCT_NAME}"
ShowInstDetails show
ShowUnInstDetails show
SetCompress off
/* --- Installer Attributes --- FINE */

/* Informazioni sulla versione, per il file system  - INIZIO */
VIAddVersionKey /LANG=${LANG_ITALIAN} "ProductName" "${PRODUCT_NAME}"
VIAddVersionKey /LANG=${LANG_ITALIAN} "CompanyName" "${PRODUCT_PUBLISHER}"
VIAddVersionKey /LANG=${LANG_ITALIAN} "LegalCopyright" " La mia ditta s.r.l."
VIAddVersionKey /LANG=${LANG_ITALIAN} "FileDescription" "La mia applicazione serve a questo e a quello"
VIAddVersionKey /LANG=${LANG_ITALIAN} "FileVersion" "${PRODUCT_VERSION}"
VIAddVersionKey /LANG=${LANG_ITALIAN} "ProductVersion" "${PRODUCT_VERSION}"
VIProductVersion "${PRODUCT_VERSION}.0.0"
/* Informazioni sulla versione, per il file system  - FINE */

/* --- Sezioni --- INIZIO */
Var AccessDir

Section "componenti base" SEC01
  SetOutPath "$INSTDIR"
  SetOverwrite ifnewer
;  SectionIn RO
  File "MyApplication.mdb" ; l'applicazione
  File "AdditionalFile.mde" ; eventuali file da distribuire insieme
  File "MyApplication.ico" ; icona per il collegamento web nel menu start
  File "MyComponent.ocx" ; eventuale componente ActiveX
  RegDLL "${INSTDIR}\RTF2.ocx"
SectionEnd
LangString DESC_SEC01 ${LANG_ITALIAN} "I file dell'applicazione."

Section "un.componenti base" UNSEC01
  Delete "$INSTDIR\MyApplication.mdb"
  Delete "$INSTDIR\AdditionalFile.mde"
  Delete "$INSTDIR\PBsoft.ico"
  UnRegDLL "$INSTDIR\MyComponent.ocx"
  Delete "$INSTDIR\MyComponent.ocx"
  RMDir "$INSTDIR"
  SectionIn RO
SectionEnd
LangString DESC_UNSEC01 ${LANG_ITALIAN} "I file dell'applicazione."

Section /o "Access 2003 Runtime" SEC03
  SetOutPath "$INSTDIR\Runtime"
  File "ACCESSRT.CAB"
  File "ACCESSRT.MSI"
  ExecWait 'msiexec /i "$INSTDIR\Runtime\ACCESSRT.MSI" /passive /log "$INSTDIR\Runtime\ACCESSRT.LOG"'
  ; i due seguenti settaggi eliminano il problema delle macro e delle espressioni potenzialmente pericolose
  WriteRegDWORD HKEY_LOCAL_MACHINE "SOFTWARE\Microsoft\Office\11.0\Access\Security" "level" 0x00000001
  WriteRegDWORD HKEY_LOCAL_MACHINE "SOFTWARE\Microsoft\Jet\4.0\Engines" "SandBoxMode" 0x00000002
SectionEnd
LangString DESC_SEC03 ${LANG_ITALIAN} "Ambiente Runtime di Microsoft Access 2003."

Section "un.Access 2003 Runtime" UNSEC03
  ExecWait 'msiexec /x "$INSTDIR\Runtime\ACCESSRT.MSI" /passive'
  DeleteRegValue HKEY_LOCAL_MACHINE "SOFTWARE\Microsoft\Office\11.0\Access\Security" "level"
  DeleteRegKey /ifempty HKEY_LOCAL_MACHINE "SOFTWARE\Microsoft\Office\11.0\Access\Security"
  WriteRegDWORD HKEY_LOCAL_MACHINE "SOFTWARE\Microsoft\Jet\4.0\Engines" "SandBoxMode" 0x00000003
  Delete "$INSTDIR\Runtime\ACCESSRT.CAB"
  Delete "$INSTDIR\Runtime\ACCESSRT.MSI"
  Delete "$INSTDIR\Runtime\ACCESSRT.LOG"
  RMDir "$INSTDIR\Runtime"
SectionEnd
LangString DESC_UNSEC03 ${LANG_ITALIAN} "Ambiente Runtime di Microsoft Access 2003."

Section "collegamenti menu Start" SEC04
  Call Access2003GetPath ; recupera il percorso del file MSACCESS.EXE
  WriteIniStr "$INSTDIR\${PRODUCT_NAME}.url" "InternetShortcut" "URL" "${PRODUCT_WEB_SITE}"
  CreateDirectory "$SMPROGRAMS\My Application"
  CreateShortCut "$SMPROGRAMS\My Application\My Application.lnk" "$AccessDir\MSACCESS.EXE" "$INSTDIR\Service.adp" "$INSTDIR\MyApplication.ico" 0 ; per avviare l'applicazione
  CreateShortCut "$SMPROGRAMS\My Application\MyApplication.lnk" "$INSTDIR\${PRODUCT_NAME}.url" "" "" ; www.ilsitodellamiaditta.it
  CreateShortCut "$SMPROGRAMS\My Application\Uninstall.lnk" "$INSTDIR\${PRODUCT_NAME}Uninst.exe" ; per rimuovere l'applicazione
SectionEnd
LangString DESC_SEC04 ${LANG_ITALIAN} "Collegamenti per avviare l'applicazione dal menu Start."

Section "-un.collegamenti menu Start" UNSEC04
  Delete "$SMPROGRAMS\Service\Uninstall.lnk"
  Delete "$SMPROGRAMS\Service\My Application.lnk"
  Delete "$SMPROGRAMS\Service\MyApplication.lnk"
  Delete "$INSTDIR\${PRODUCT_NAME}.url"
  RMDir "$SMPROGRAMS\My Application"
SectionEnd

Section -Post
  WriteUninstaller "$INSTDIR\${PRODUCT_NAME}Uninst.exe"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "DisplayName" "$(^Name)"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "UninstallString" "$INSTDIR\${PRODUCT_NAME}Uninst.exe"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "DisplayVersion" "${PRODUCT_VERSION}"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "URLInfoAbout" "${PRODUCT_WEB_SITE}"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "Publisher" "${PRODUCT_PUBLISHER}"
SectionEnd

Section -un.Post
  Delete "$INSTDIR\${PRODUCT_NAME}Uninst.exe"
  DeleteRegKey ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}"
  RMDir "$INSTDIR"
SectionEnd

!insertmacro MUI_FUNCTION_DESCRIPTION_BEGIN
  !insertmacro MUI_DESCRIPTION_TEXT ${SEC01} $(DESC_SEC01)
  !insertmacro MUI_DESCRIPTION_TEXT ${SEC03} $(DESC_SEC03)
  !insertmacro MUI_DESCRIPTION_TEXT ${SEC04} $(DESC_SEC04)
!insertmacro MUI_FUNCTION_DESCRIPTION_END

!insertmacro MUI_UNFUNCTION_DESCRIPTION_BEGIN
  !insertmacro MUI_DESCRIPTION_TEXT ${UNSEC01} $(DESC_UNSEC01)
  !insertmacro MUI_DESCRIPTION_TEXT ${UNSEC03} $(DESC_UNSEC03)
!insertmacro MUI_UNFUNCTION_DESCRIPTION_END
/* --- Sezioni --- FINE */

/* --- Funzioni --- INIZIO */
Function .onInit
  Call Access2003GetPath ; recupera il percorso del file MSACCESS.EXE eventualmente gi presente
  ${If} $AccessDir == "" ; Access non  installato sulla macchina
    IntOp $0 ${SF_SELECTED} | ${SF_BOLD}
    SectionSetFlags ${SEC03} $0
  ${Else} ; Access  gi installato sulla macchina
    SectionSetFlags ${SEC03} ${SF_RO}
  ${endIf}
FunctionEnd

Function Access2003GetPath
  ReadRegStr $AccessDir HKEY_LOCAL_MACHINE "SOFTWARE\Microsoft\Office\11.0\Access\InstallRoot" "Path"
FunctionEnd
/* --- Funzioni --- FINE */